var dataDomain = ""

function setDataDomain(domain) {
    dataDomain = domain
}


var corner1 = L.latLng(80, 180 + 360),
    corner2 = L.latLng(-80, -180 - 360),
    bounds = L.latLngBounds(corner1, corner2);
var map = L.map('map', {
    // crs: L.CRS.Baidu,
    // crs:L.CRS.EPSG4326,
    minZoom: 4,
    maxZoom: 14,
    attributionControl: false,
    maxBounds: bounds,
    center: [39.91583, 116.39085],
    zoom: 6,
    zoomControl: false,
    // layer:[layer]
});

$.blockUI({
    message: "<div class=\"loading\">\n" +
        "            <div class=\"loading-box\">\n" +
        "                <i class=\"fade-item fade-item1\"></i>\n" +
        "                <i class=\"fade-item fade-item2\"></i>\n" +
        "                <i class=\"fade-item fade-item3\"></i>\n" +
        "                <i class=\"fade-item fade-item4\"></i>\n" +
        "                <i class=\"fade-item fade-item5\"></i>\n" +
        "                <i class=\"fade-item fade-item6\"></i>\n" +
        "                <i class=\"fade-item fade-item7\"></i>\n" +
        "                <i class=\"fade-item fade-item8\"></i>\n" +
        "                <i class=\"fade-item fade-item9\"></i>\n" +
        "                <i class=\"fade-item fade-item10\"></i>\n" +
        "                <i class=\"fade-item fade-item11\"></i>\n" +
        "                <i class=\"fade-item fade-item12\"></i>\n" +
        "            </div>\n" +
        "        </div>",
    css: {
        border: 'none',
        // padding: '15px',
        backgroundColor: 'none',
        left: '40%',
        // border:unset,
        // '-webkit-border-radius': '10px',
        // '-moz-border-radius': '10px',
        // opacity: .5,
        // color: '#fff'
    }
});

// 根据flutter的定位,设置地图的中心位置
function setCenter(lat, lon, zoom) {

    if (lat == undefined || lon == undefined) {
        lat = 39.91583
        lon = 116.39085
    }
    var latlng = L.latLng(lat, lon);
    if (zoom == undefined) {
        zoom = map.getZoom();
    }
    map.setView(latlng, zoom)
}

// 根据URL计算地图边缘数据
function getMapBounds() {
    var latlng = map.getBounds();
    var zoom = map.getZoom();
    var lat1 = latlng['_southWest'].lat;
    var lat2 = latlng['_northEast'].lat;
    var lon1 = latlng['_southWest'].lng;
    var lon2 = latlng['_northEast'].lng;
    return [lat1, lat2, lon1, lon2, zoom];
}


var velocityLayer;
//var velocityLayer;

//L.tileLayer.bing({bingMapsKey:'Ao2ox3HJQN4TqxdEi013dGS_8SSHdOrTDqz30m9nY6V1we_Ww6cBfv5bQOgZBVBe',imagerySet:'CanvasDark',culture:'zh-CN'}).addTo(map);

// layer.addTo(map);
// L.tileLayer.wms('https://ahocevar.com/geoserver/wms', {
//     // zoomOffset: 1,
//
//     layers: 'ne:NE1_HR_LC_SR_W_DR'
// }).addTo(map);


// var data;
var bandsWindLayer;
var page = 1;
clicked = true;
var uptime;
var layerList = {};
var beforPage = 0;
var step = 30;
var imgLayer1, imgLayer2, imgLayer3;
var urlPrefix = "";
var layer, layer1;
var language = 'zh-CN';
$('.arrow').hide()

function toSpeedDir(u, v) {
    speed = Math.round(Math.sqrt(u * u + v * v) * 10000) / 10000;
    dir = -Math.atan2(-u, v) * 180.0 / Math.PI + 180;
    if (dir < 0) dir += 360.0;
    else if (dir >= 360) dir -= 360.0;
    dir = Math.round(dir);
    return [speed, dir]
}

function fromSpeedDir(speed, dir) {
    var rad = 4.0 * Math.atan(1.0) / 180.;
    u = -1 * speed * Math.sin(rad * dir);
    v = -1 * speed * Math.cos(rad * dir);
    return [u, v]
}

function getLevel(h) {
    var level = 0;
    if (h >= 56.1) {
        level = 17
    } else if (h >= 51) {
        level = 16
    } else if (h >= 46.2) {
        level = 15
    } else if (h >= 41.5) {
        level = 14
    } else if (h >= 37) {
        level = 13
    } else if (h >= 32.7) {
        level = 12
    } else if (h >= 28.5) {
        level = 11
    } else if (h >= 24.5) {
        level = 10
    } else if (h >= 20.8) {
        level = 9
    } else if (h >= 17.2) {
        level = 8
    } else if (h >= 13.9) {
        level = 7
    } else if (h >= 10.8) {
        level = 6
    } else if (h >= 8) {
        level = 5
    } else if (h >= 5.5) {
        level = 4
    } else if (h >= 3.4) {
        level = 3
    } else if (h >= 1.6) {
        level = 2
    } else if (h >= 0.3) {
        level = 1
    } else {
        level = h / 0.3
    }
    return level
}

function toLevel(u, v) {
    speedDir = toSpeedDir(u, v);
    h = speedDir[0];
    var level = 0;
    if (h >= 32.7) {
        level = 12 + (h - 32.7) / 10
    } else if (h >= 28.5) {
        level = 11 + ((h - 28.5) / (32.7 - 28.5))
    } else if (h >= 24.5) {
        level = 10 + ((h - 24.5) / (28.5 - 24.5))
    } else if (h >= 20.8) {
        level = 9 + ((h - 20.8) / (24.5 - 20.8))
    } else if (h >= 17.2) {
        level = 8 + ((h - 17.2) / (20.8 - 17.2))
    } else if (h >= 13.9) {
        level = 7 + ((h - 13.9) / (17.2 - 13.9))
    } else if (h >= 10.8) {
        level = 6 + ((h - 10.8) / (13.9 - 10.8))
    } else if (h >= 8) {
        level = 5 + ((h - 8) / (10.8 - 8))
    } else if (h >= 5.5) {
        level = 4 + ((h - 5.5) / (8 - 5.5))
    } else if (h >= 3.4) {
        level = 3 + ((h - 3.4) / (5.5 - 3.4))
    } else if (h >= 1.6) {
        level = 2 + ((h - 1.6) / (3.4 - 1.6))
    } else if (h >= 0.3) {
        level = 1 + ((h - 0.3) / (1.6 - 0.3))
    } else {
        level = h / 0.3
    }
    return fromSpeedDir(level, speedDir[1]);
}

function fromLevel(u, v) {
    speedDir = toSpeedDir(u, v);
    h = speedDir[0];
    var speed;
    if (h >= 12) {
        speed = (h - 12) * 10 + 32.7;
    } else if (h >= 11) {
        speed = (h - 11) * (32.7 - 28.5) + 28.5;
    } else if (h >= 10) {
        speed = (h - 10) * (28.5 - 24.5) + 24.5;
    } else if (h >= 9) {
        speed = (h - 9) * (24.5 - 20.8) + 20.8;
    } else if (h >= 8) {
        speed = (h - 8) * (20.8 - 17.2) + 17.2;
    } else if (h >= 7) {
        speed = (h - 7) * (17.2 - 13.9) + 13.9;
    } else if (h >= 6) {
        speed = (h - 6) * (13.9 - 10.8) + 10.8;
    } else if (h >= 5) {
        speed = (h - 5) * (10.8 - 8) + 8;
    } else if (h >= 4) {
        speed = (h - 4) * (8 - 5.5) + 5.5;
    } else if (h >= 3) {
        speed = (h - 3) * (5.5 - 3.4) + 3.4;
    } else if (h >= 2) {
        speed = (h - 2) * (3.4 - 1.6) + 1.6;
    } else if (h >= 1) {
        speed = (h - 1) * (1.6 - 0.3) + 0.3;
    } else {
        speed = h * 0.3
    }
    return [speed, speedDir[1]]
}

function load(url, callback) {
    var myRequest = new Request(url);
    fetch(myRequest).then(function (response) {
        return response.arrayBuffer();
    }).then(function (buffer) {
        let imgData = pako.inflate(new Uint8Array(buffer));

        let ret = {uo: [], vo: []};
        let i = 0;
        while (i < imgData.length) {
            let b1 = imgData[i] << 8;
            i++;
            let b2 = imgData[i];
            i++;

            let b3 = imgData[i] << 8;
            i++;
            let b4 = imgData[i];
            i++;
            vector = toLevel((b1 + b2) > 0 ? (b1 + b2 - 32767) / 100 : 0, (b3 + b4) > 0 ? (b3 + b4 - 32767) / 100 : 0);
            ret.uo.push(vector[0]);
            ret.vo.push(vector[1])

        }
        return callback(ret, null)
    }).catch((error) => {
        return callback(null, error)
    });
}

//function load(url, callback) {
//    const xhr = new XMLHttpRequest();
//    xhr.open('GET', url, true);
//    xhr.responseType = 'arraybuffer';
//    xhr.timeout = 5000;
//
//    xhr.onload = () => {
//        const data = new Uint8Array(xhr.response || xhr.mozResponseArrayBuffer);
//
//        let imgData = pako.inflate(new Uint8Array(data));
//
//        let ret = { uo: [], vo: [] };
//        let i = 0;
//        while (i < imgData.length) {
//            let b1 = imgData[i] << 8;
//            i++;
//            let b2 = imgData[i];
//            i++;
//
//            let b3 = imgData[i] << 8;
//            i++;
//            let b4 = imgData[i];
//            i++;
//            vector = toLevel((b1 + b2) > 0 ? (b1 + b2 - 32767) / 100 : 0, (b3 + b4) > 0 ? (b3 + b4 - 32767) / 100 : 0);
//            ret.uo.push(vector[0]);
//            ret.vo.push(vector[1])
//
//        }
//        return callback(ret, null)
//    };
//    xhr.onerror = (error) => {
//        return callback(null, error)
//    };
//    xhr.ontimeout = function (e) {
//        return callback(null, e)
//        // XMLHttpRequest 超时。在此做某事。
//    };
//    return xhr.send(null);
//}

function getJSON(i, j, step) {
    return new Promise(resolve => {
        while (j < 0) j = j + 360;
        load(urlPrefix + page + '_' + (i - 0 + 90) + '_' + j + '.dat', function (ret, err) {

            if (err) {
                console.log(err)
                $.unblockUI();
                $('.error').show()
                $('.data').hide()
                // $.blockUI({
                //     message: /zh/.test(language) ? '数据请求失败,请移动地图重新加载数据' : 'Connection failed, Move map to reconnected',
                //     css: {
                //         border: 'none',
                //         padding: '15px',
                //         backgroundColor: '#000',
                //         '-webkit-border-radius': '10px',
                //         '-moz-border-radius': '10px',
                //         opacity: .5,
                //         color: '#fff'
                //     }
                // });
                if (velocityLayer) {
                    map.removeLayer(velocityLayer)
                    velocityLayer = null
                }
                // setTimeout($.unblockUI, 2000);
                return resolve('err')
            }
            layerList[page + '_' + i + '_' + j] = ret;
            resolve('resolved');

        })

    })
}

function init(domain, lang, url, p, imgUrl) {
    dataDomain = domain;
    language = lang;
    urlPrefix = url;
    page = p;
    if (imgUrl) {
        if (imgLayer1) {
            map.removeLayer(imgLayer1);
            map.removeLayer(imgLayer2);
            map.removeLayer(imgLayer3);
        }
        var imageUrl = imgUrl,
            imageBounds = [[-80, 0], [80, 360]];
        imgLayer1 = L.imageOverlay(imageUrl, imageBounds, {opacity: 0.6});
        imageBounds = [[-80, 360], [80, 360 + 360]];
        imgLayer2 = L.imageOverlay(imageUrl, imageBounds, {opacity: 0.6});
        imageBounds = [[-80, -360], [80, 0]];
        imgLayer3 = L.imageOverlay(imageUrl, imageBounds, {opacity: 0.6});
        imgLayer1.addTo(map);
        imgLayer2.addTo(map);
        imgLayer3.addTo(map);
    }
    layer = L.tileLayer('https://t{s}.tianditu.gov.cn/DataServer?T=vec_w&x={x}&y={y}&l={z}&tk=4f3b654bf06e2d571e24c9ee3791071d', {
        subdomains: ["0", "1", "2", "3", "4", "5", "6", "7"],
        maxZoom: 18,
        minZoom: 4,
        zIndex: 1000,
        // zoomOffset: 1
    });
    if (/zh/.test(language)) {
        layer1 = L.tileLayer('https://t{s}.tianditu.gov.cn/DataServer?T=cva_w&x={x}&y={y}&l={z}&tk=4f3b654bf06e2d571e24c9ee3791071d', {
            subdomains: ["0", "1", "2", "3", "4", "5", "6", "7"],
            maxZoom: 18,
            minZoom: 4,
            zIndex: 1000,
            // zoomOffset: 1
        });
    } else {
        layer1 = L.tileLayer('https://t{s}.tianditu.gov.cn/DataServer?T=eva_w&x={x}&y={y}&l={z}&tk=4f3b654bf06e2d571e24c9ee3791071d', {
            subdomains: ["0", "1", "2", "3", "4", "5", "6", "7"],
            maxZoom: 18,
            minZoom: 4,
            zIndex: 1000,
            // zoomOffset: 1
        });
        $('#detail').html('Detail');
        $('#speedLabel').html('Wind Speed');
        $('#elevation').html('Elevation');
        $("#levelLabel").html("Level");
        $("#dirLabel").html("Direction")
    }


    layer.addTo(map);
    layer1.addTo(map);
    $('#error').html(/zh/.test(language) ? '数据加载失败, 请移动地图重新加载数据' : 'Connection failed, Move map to reconnected')
    $('.error').hide()
    $('.data').show()
}

//设置时间
function setTime(timeStr) {
    //    $('#time').html(timeStr.replace(/(^\d*-\d*-\d*\s*\d*:\d*).*/,'$1'))
    //    $('#name').html(timeStr.replace(/^\d*-\d*-\d*\s*\d*:\d*(.*)/,'$1').trim())
    //    $('#date').html(timeStr)
}

// 设置地图数据
async function setMapData() {

    $.blockUI({
        message: "<div class=\"loading\">\n" +
            "            <div class=\"loading-box\">\n" +
            "                <i class=\"fade-item fade-item1\"></i>\n" +
            "                <i class=\"fade-item fade-item2\"></i>\n" +
            "                <i class=\"fade-item fade-item3\"></i>\n" +
            "                <i class=\"fade-item fade-item4\"></i>\n" +
            "                <i class=\"fade-item fade-item5\"></i>\n" +
            "                <i class=\"fade-item fade-item6\"></i>\n" +
            "                <i class=\"fade-item fade-item7\"></i>\n" +
            "                <i class=\"fade-item fade-item8\"></i>\n" +
            "                <i class=\"fade-item fade-item9\"></i>\n" +
            "                <i class=\"fade-item fade-item10\"></i>\n" +
            "                <i class=\"fade-item fade-item11\"></i>\n" +
            "                <i class=\"fade-item fade-item12\"></i>\n" +
            "            </div>\n" +
            "        </div>",
        css: {
            border: 'none',
            // padding: '15px',
            backgroundColor: 'none',
            left: '40%',
            // border:unset,
            // '-webkit-border-radius': '10px',
            // '-moz-border-radius': '10px',
            // opacity: .5,
            // color: '#fff'
        }
    });
    var latlng = map.getBounds();
    var zoom = map.getZoom();
    var lat1 = latlng['_southWest'].lat;
    var lat2 = latlng['_northEast'].lat;
    var lon1 = latlng['_southWest'].lng;
    var lon2 = latlng['_northEast'].lng;
    while (lon1 <= -180) {
        lon1 = lon1 + 360;
        lon2 = lon2 + 360;
    }
    while (lon2 >= 360) {
        lon1 = lon1 - 360;
        lon2 = lon2 - 360;
    }
    lat1 = Math.floor(lat1 / step) * step;
    lat2 = Math.floor(lat2 / step) * step;
    lon1 = Math.floor(lon1 / step) * step;
    lon2 = Math.floor(lon2 / step) * step;
    var data = {data: [{data: []}, {data: []}]};
    var json = {};
    for (var i = lat2; i >= lat1; i = i - step) {
        for (var j = lon1; j <= lon2; j = j + step) {
            var l = j;
            if (l < 0) l = l + 360
            if (!layerList[page + '_' + i + '_' + l]) {
                json[page + '_' + i + '_' + j] = getJSON(i, j, step)
            }
        }
        for (var b = 0; b < step * (256 / 30); b++) {
            for (var a = lon1; a <= lon2; a = a + step) {
                for (var c = 0; c < step * (256 / 30); c++) {
                    var l = a;
                    if (l < 0) l = l + 360
                    if (!layerList[page + '_' + i + '_' + l]) await json[page + '_' + i + '_' + a]
                    if (layerList[page + '_' + i + '_' + l] && layerList[page + '_' + i + '_' + l].uo) {
                        data.data[0].data.push(layerList[page + '_' + i + '_' + l].uo[c + b * step * (256 / 30)]);
                        data.data[1].data.push(layerList[page + '_' + i + '_' + l].vo[c + b * step * (256 / 30)]);
                    } else {
                        $.unblockUI();
                        $('.error').show()
                        $('.data').hide()
                        // $.blockUI({
                        //     message: /zh/.test(language) ? '数据请求失败,请移动地图重新加载数据' : 'Connection failed, Move map to reconnected',
                        //     css: {
                        //         border: 'none',
                        //         padding: '15px',
                        //         backgroundColor: '#000',
                        //         '-webkit-border-radius': '10px',
                        //         '-moz-border-radius': '10px',
                        //         opacity: .5,
                        //         color: '#fff'
                        //     }
                        // });
                        if (velocityLayer) {
                            map.removeLayer(velocityLayer)
                            velocityLayer = null
                        }
                        delete layerList[page + '_' + i + '_' + l]
                        // setTimeout($.unblockUI, 2000);
                        return;
                    }

                }
            }
        }

    }

    data.data[0].header = {

        "parameterUnit": "m.s-1",
        "parameterNumber": 2,
        "dx": 1 / (256 / 30),
        "dy": 1 / (256 / 30),
        "parameterNumberName": "eastward_wind",
        "la1": lat2 + step,
        "la2": lat1,
        "parameterCategory": 2,
        "lo2": lon2 + step,
        "nx": (lon2 - lon1 + step) * (256 / 30),
        "ny": (lat2 - lat1 + step) * (256 / 30),
        "lo1": lon1
    };
    data.data[1].header = {

        "parameterUnit": "m.s-1",
        "parameterNumber": 3,
        "dx": 1 / (256 / 30),
        "dy": 1 / (256 / 30),
        "parameterNumberName": "eastward_wind",
        "la1": lat2 + step,
        "la2": lat1,
        "parameterCategory": 2,
        "lo2": lon2 + step,
        "nx": (lon2 - lon1 + step) * (256 / 30),
        "ny": (lat2 - lat1 + step) * (256 / 30),
        "lo1": lon1
    };
    if (velocityLayer) {
        //        map.removeLayer(velocityLayer)
        velocityLayer.setData(data.data)
    } else {
        velocityLayer = L.velocityLayer({
            displayValues: false,
            displayOptions: {
                velocityType: "Global CMEMS",
                displayPosition: "bottomleft",
                displayEmptyString: "No cmems data"
            },
            data: data.data,
            maxVelocity: 10,
            frameRate: 30,
            windType: 'round',
            type: 'wind',
            colorScale: [
                "rgb(39,113,178)",
                "rgb(2,152,187)",
                "rgb(0,143,90)",
                "rgb(139,200,0)",
                "rgb(255,255,1)",
                "rgb(255,200,1)",
                "rgb(255,144,0)",
                "rgb(255,98,1)",
                "rgb(254,0,0)",
                "rgb(199,0,125)"
            ],

            lineWidth: 1,
            particleMultiplier: 1 / 600,//粒子的数量


        });
        map.addLayer(velocityLayer)
    }
    $('.error').hide()
    $('.data').show()
    $.unblockUI();
    if ($('.dir').text().trim().length < 2) {
        setTimeout(function () {
            moveEvent(map.getCenter());
            getDepth(map.getCenter().lat, map.getCenter().lng);
        }, 1000)
    }
}


map.on('movestart', function () {
    // if(velocityLayer){
    //     map.removeLayer(velocityLayer);
    // }
})

function formatDegree(value) {
    ///<summary>将度转换成为度分秒</summary>
    value = Math.abs(value);
    var v1 = Math.floor(value);//度
    var v2 = Math.floor((value - v1) * 60);//分
    var v3 = Math.round((value - v1) * 3600 % 60);//秒
    return v1 + '° ' + ("00" + v2).slice(-2) + '\' ' + ("00" + v3).slice(-2) + '" ';
}

var marker;
var markerLatlng;

$('.close').click(function () {
    $('.message').removeClass('active');
    $('#lat').html('')
    $('#lon').html('')
    if (marker) marker.remove();
})

function getCmems(lat, lng) {
    var geohash = encodeGeoHash(lat, lng);

}

function getUV(latlng) {
    if (velocityLayer != null && velocityLayer._map) {
        var pos = velocityLayer._map.containerPointToLatLng(map.latLngToContainerPoint(latlng));
        var gridValue;
        if (velocityLayer != null && velocityLayer._windy != null) gridValue = velocityLayer._windy.interpolatePoint(pos.lng, pos.lat);
        if (gridValue && !isNaN(gridValue[0]) && !isNaN(gridValue[1]) && gridValue[2]) {
            u = gridValue[0]
            v = gridValue[1]
            speedDir = fromLevel(u, v);
            $('#dir').html(speedDir[1] + "°")
            var l = /zh/.test(language) ? "" + getLevel(Math.floor(speedDir[0])) + "级" : getLevel(Math.floor(speedDir[0]));
            $('#speed').html(convertSpeed(speedDir[0]));
            $('#level').html(l);
            $('.arrow').show();
            $("#dirName").html(getWindDirName(speedDir[1], language));
            $('.arrow img').css({
                "-webkit-transform": "rotate(" + dir + "deg)",
                "-moz-transform": "rotate(" + dir + "deg)",
                "transform": "rotate(" + dir + "deg)" /* For modern browsers(CSS3)  */
            });
        } else {
            $('.arrow').hide();
            $('#dir').html(" - ");
            $('#speed').html(" - ");
            $('#level').html(" - ");
            $('#dirName').html(" - ");
        }
    }

}

function moveEvent(latlng) {


    var lng = latlng.lng
    while (lng > 180) {
        lng = lng - 360
    }
    while (lng < -180) {
        lng = lng + 360
    }
    $('#lat').html((latlng.lat > 0 ? 'N ' : 'S ') + "<span style='color:orange'>" + formatDegree(latlng.lat)) + "</span>"
    $('#lon').html((lng > 0 ? 'E ' : 'W ') + "<span style='color:orange'>" + formatDegree(lng)) + "</span>"
    getUV(latlng);

}

function getDepth(lat, lng) {
    while (lng > 180) {
        lng = lng - 360
    }
    while (lng < -180) {
        lng = lng + 360
    }
    if ($('#dir').text().trim().length > 1) {
        if (dataDomain.length > 0) {
            var geohash = encodeGeoHash(lat, lng);
            $.getJSON(dataDomain + '/type/v5/getDepth', {geohash: geohash}, function (ret) {
                if (ret.code == 0) {
                    $('#depth').html(convertHeight(ret.data.depth))
                } else {
                    $('#depth').html('error')
                }
            })
        }

    } else {
        $('#depth').html('-')
    }
}

$('.close').click(function () {
    $('.message').removeClass('active');
    $('#lat').html('')
    $('#lon').html('')
    if (marker) marker.remove();
})

map.on('contextmenu', function (e) {
    //    makeMarker(e.latlng)

})
map.on('click', function (e) {
})
map.on('zoomend', function (e) {
})
map.on('move', function (e) {
    $('.error').hide()
    $(".data").show()
    moveEvent(map.getCenter());
})
map.on('moveend', function (e) {

    if (velocityLayer) {
        //velocityLayer._clearAndRestart();
        //        map.removeLayer(velocityLayer)
    }
    getDepth(map.getCenter().lat, map.getCenter().lng);
    //    setTimeout(function () {
    //        window.nativeWebView.callHandler("loadData", map.getCenter().lat, map.getCenter().lng);
    //    }, 300);
    setMapData();
    //    getData();

})

function go2Detail() {
    var lat = map.getCenter().lat;
    var lon = map.getCenter().lng;
    while (lat > 180) {
        lat = lat - 360;
    }
    while (lon > 180) {
        lon = lon - 360;
    }
    while (lat < -180) {
        lat = lat + 360;
    }
    while (lon < -180) {
        lon = lon + 360;
    }
    window.nativeWebView.callHandler("go2Detail", lat, lon);
}

//$('#go2Detail').bind('click', function () {
//    var lat = map.getCenter().lat;
//    var lon = map.getCenter().lng;
//    while (lat > 180) {
//        lat = lat - 360;
//    }
//    while (lon > 180) {
//        lon = lon - 360;
//    }
//    while (lat < -180) {
//        lat = lat + 360;
//    }
//    while (lon < -180) {
//        lon = lon + 360;
//    }
//    window.nativeWebView.callHandler("go2Detail", lat, lon);
//})
$("#select").bind('click', function () {
    window.nativeWebView.callHandler("go2Select");
})
// $('.locate').bind('click', function () {
//     window.nativeWebView.callHandler("setCenter", "wind")
// })